events.listen('item.tags', function (e) {
  
  //Valid Apiary  
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_dark_ethereal')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_dark_ethereal_reverse')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_ethereal')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_ethereal_reverse')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_ghostly')

  //Yellorium
  e.get('forge:ingots/uranium').remove('bigreactors:yellorium_ingot')
  e.get('forge:dusts/uranium').remove('bigreactors:yellorium_dust')
  e.get('forge:ores/uranium').remove('bigreactors:yellorite_ore')
  e.add('forge:ores/yellorite', 'bigreactors:yellorite_ore')
  e.add('forge:ores/endumium', 'farlanders:endumium_ore')

  //Plates
  //Lapis Plate
  e.add('forge:plates/lapis_lazuli', 'kubejs:lapis_plate')
  e.add('forge:plates', 'kubejs:lapis_plate')
  //Brass Plate
  e.add('forge:plates/brass', 'kubejs:brass_plate')
  e.add('forge:plates', 'kubejs:brass_plate')
  //Zinc Plate
  e.add('forge:plates/zinc', 'kubejs:zinc_plate')
  e.add('forge:plates', 'kubejs:zinc_plate')

  e.add('forge:ingots/red_alloy', 'bluepower:red_alloy_ingot')
  e.add('forge:ingots/redstone_alloy', 'bluepower:red_alloy_ingot')
  e.add('forge:ingots/platinum', 'kubejs:platinum_ingot')
  e.add('forge:nuggets/platinum', 'kubejs:platinum_nugget')
  e.add('forge:storage_blocks/platinum', 'kubejs:platinum_block')

  //Beehives
  e.add('minecraft:beehives', 'buzzier_bees:spruce_beehive')
  e.add('minecraft:beehives', 'buzzier_bees:birch_beehive')
  e.add('minecraft:beehives', 'buzzier_bees:jungle_beehive')
  e.add('minecraft:beehives', 'buzzier_bees:acacia_beehive')
  e.add('minecraft:beehives', 'buzzier_bees:dark_oak_beehive')
  e.add('minecraft:beehives', 'buzzier_bees:crimson_beehive')
  e.add('minecraft:beehives', 'buzzier_bees:warped_beehive')
  e.add('minecraft:beehives', 'endergetic:poise_beehive')
  e.add('minecraft:beehives', 'endergetic:puffbug_hive')
  e.add('minecraft:beehives', 'upgrade_aquatic:driftwood_beehive')
  e.add('minecraft:beehives', 'upgrade_aquatic:river_beehive')
  e.get('minecraft:beehives').remove('resourcefulbees:t1_beehive')
  e.get('minecraft:beehives').remove('resourcefulbees:t2_beehive')
  e.get('minecraft:beehives').remove('resourcefulbees:t3_beehive')
  e.get('minecraft:beehives').remove('resourcefulbees:t4_beehive')

  e.get('forge:ingots/iron').remove('dustrial_decor:rusty_iron_ingot')
  e.get('forge:ingots/lead').remove('eidolon:lead_ingot')
  e.get('forge:ingots/copper').remove('iceandfire:copper_ingot')
  e.get('forge:nuggets/copper').remove('iceandfire:copper_nugget')
  e.remove('twilightforest:portal/activator', '#forge:gems/diamond')  
  e.add('twilightforest:portal/activator', 'rats:psionic_rat_brain')

  e.add('forge:ores/gold', 'byg:brimstone_nether_gold_ore')
  e.add('forge:ores/gold', 'byg:blue_nether_gold_ore')

  e.add('forge:ores/quartz', 'byg:brimstone_nether_quartz_ore')
  e.add('forge:ores/quartz', 'byg:blue_nether_quartz_ore')
  
  e.add('forge:ores/coal', 'janoeo:coal_gravel_ore')

  e.add('forge:ores/emerald', 'janoeo:emerald_gravel_ore')

  e.add('forge:ores/dimshard', 'rftoolsbase:dimensionalshard_overworld')
  e.add('forge:ores/dimshard', 'rftoolsbase:dimensionalshard_nether')
  e.add('forge:ores/dimshard', 'rftoolsbase:dimensionalshard_end')

  e.add('forge:ores/prosperity', 'mysticalagradditions:nether_prosperity_ore')
  e.add('forge:ores/prosperity', 'mysticalagradditions:end_prosperity_ore')
  e.add('forge:ores/inferium', 'mysticalagradditions:nether_inferium_ore')
  e.add('forge:ores/inferium', 'mysticalagradditions:end_inferium_ore')
  
  //ores
  e.add('forge:ores/lapis', 'gildedingot:basalt_lapis')
  e.add('forge:ores/lapis', 'janoeo:lapis_gravel_ore')

  e.get('forge:ores/copper').remove('mekanism:copper_ore')
  e.get('forge:ores/copper').remove('immersiveengineering:ore_copper')
  e.get('forge:ores/copper').remove('iceandfire:copper_ore')
  e.get('forge:ores/copper').remove('tconstruct:copper_ore')
  e.get('forge:ores/copper').remove('janoeo:copper_ore')
  e.get('forge:ores/copper').remove('create:copper_ore')
  e.get('forge:ores/copper').remove('bluepower:copper_ore')

  e.get('forge:ores/tin').remove('mekanism:tin_ore')
  e.get('forge:ores/tin').remove('janoeo:tin_ore')

  e.get('forge:ores/silver').remove('immersiveengineering:ore_silver')
  e.get('forge:ores/silver').remove('iceandfire:silver_ore')
  e.get('forge:ores/silver').remove('bluepower:silver_ore')
  e.get('forge:ores/silver').remove('janoeo:silver_ore')

  e.get('forge:ores/uranium').remove('mekanism:uranium_ore')
  e.get('forge:ores/uranium').remove('immersiveengineering:ore_uranium')

  e.get('forge:ores/zinc').remove('create:zinc_ore')
  e.get('forge:ores/zinc').remove('bluepower:zinc_ore')

  e.get('forge:ores/lead').remove('mekanism:lead_ore')
  e.get('forge:ores/lead').remove('immersiveengineering:ore_lead')
  e.get('forge:ores/lead').remove('eidolon:lead_ore')
  e.get('forge:ores/lead').remove('janoeo:lead_ore')

  e.get('forge:ores/nickel').remove('immersiveengineering:ore_nickel')

  e.get('forge:ores/aluminum').remove('immersiveengineering:ore_aluminum')

  e.get('forge:ores/osmium').remove('janoeo:osmium_ore')

  e.get('forge:ores/sapphire').remove('janoeo:sapphire_ore')
  e.get('forge:ores/sapphire').remove('janoeo:sapphire_nether_ore')
  e.get('forge:ores/sapphire').remove('thermal:sapphire_ore')
  e.get('forge:ores/ruby').remove('janoeo:ruby_ore')
  e.get('forge:ores/ruby').remove('janoeo:ruby_nether_ore')
  e.get('forge:ores/ruby').remove('thermal:ruby_ore')
  e.get('forge:ores/amethyst').remove('janoeo:amethyst_ore')

  //Dust
  e.get('forge:dusts/copper').remove('immersiveengineering:dust_copper')
  e.get('forge:dusts/copper').remove('janoeo:copper_dust')
  e.get('forge:dusts/copper').remove('mekanism:dust_copper')
  e.get('forge:dusts/coal').remove('janoeo:coal_dust')
  e.get('forge:dusts/lapis').remove('mekanism:dust_lapis_lazuli')
  e.get('forge:dusts/lapis').remove('janoeo:lapis_dust')
  e.get('forge:dusts/steel').remove('immersiveengineering:dust_steel')
  e.get('forge:dusts/aluminum').remove('immersiveengineering:dust_aluminum')
  e.get('forge:dusts/emerald').remove('mekanism:dust_emerald')
  e.get('forge:dusts/emerald').remove('janoeo:emerald_dust')
  e.get('forge:dusts/iron').remove('immersiveengineering:dust_iron')
  e.get('forge:dusts/iron').remove('mekanism:dust_iron')
  e.get('forge:dusts/iron').remove('janoeo:iron_dust')
  e.get('forge:dusts/gold').remove('immersiveengineering:dust_gold')
  e.get('forge:dusts/gold').remove('janoeo:gold_dust')
  e.get('forge:dusts/gold').remove('mekanism:dust_gold')
  e.get('forge:dusts/diamond').remove('mekanism:dust_diamond')
  e.get('forge:dusts/nickel').remove('immersiveengineering:dust_nickel')
  e.get('forge:dusts/silver').remove('immersiveengineering:dust_silver')
  e.get('forge:dusts/lead').remove('immersiveengineering:dust_lead')
  e.get('forge:dusts/lead').remove('mekanism:dust_lead')
  e.get('forge:dusts/tin').remove('mekanism:dust_tin')
  e.get('forge:dusts/uranium').remove('mekanism:dust_uranium')
  e.get('forge:dusts/uranium').remove('immersiveengineering:dust_uranium')
  e.get('forge:dusts/sulfur').remove('immersiveengineering:dust_sulfur')
  e.get('forge:dusts/sulfur').remove('mekanism:dust_sulfur')
  e.get('forge:dyes/yellow').remove('mekanism:dust_sulfur')
  e.get('forge:dyes').remove('mekanism:dust_sulfur')
  e.get('forge:dusts/sulfur').remove('eidolon:sulfur')
  e.get('forge:dusts/obsidian').remove('mekanism:dust_obsidian')
  e.get('forge:dusts/quartz').remove('mekanism:dust_quartz')
  e.get('forge:dusts/wood').remove('mekanism:sawdust')
  e.get('forge:dusts/wood').remove('immersiveengineering:dust_wood')
  e.get('forge:dusts/sapphire').remove('thermal:sapphire_dust')
  e.get('forge:dusts/ruby').remove('thermal:ruby_dust')

  //Other
  e.get('forge:rods/wooden').remove('immersiveengineering:stick_treated')
  e.get('forge:rods').remove('immersiveengineering:stick_treated')
  e.get('forge:wires/copper').remove('createaddition:copper_wire')
  e.get('forge:bones/wither').remove('iceandfire:witherbone')
  e.get('architects_palette:withered_bones').remove('iceandfire:witherbone')
  e.get('forge:wither_bones').remove('bhc:wither_bone')
  e.get('forge:gems/ruby').remove('thermal:ruby')
  e.get('forge:gems/ruby').remove('janoeo:ruby')
  e.get('forge:gems/sapphire').remove('thermal:sapphire')
  e.get('forge:gems/sapphire').remove('janoeo:sapphire')
  e.get('forge:gems/sapphire').remove('iceandfire:sapphire_gem')
  e.get('forge:gems/amethyst').remove('iceandfire:amythest_gem')
  e.get('forge:gems/amethyst').remove('janoeo:amethyst')
  e.get('forge:rods/steel').remove('mapperbase:steel_rod')
  e.get('forge:bitumen').remove('immersivepetroleum:bitumen')
  e.get('forge:ingots/brass').remove('bluepower:brass_ingot')
  e.get('forge:ingots/tin').remove('mekanism:ingot_tin')
  e.get('forge:ingots/copper').remove('mekanism:ingot_copper')
  e.get('forge:ingots/copper').remove('immersiveengineering:ingot_copper')
  e.get('forge:wires').remove('createaddition:copper_wire')
  
  e.add('forge:shard/prosperity', 'mysticalagriculture:prosperity_shard')
  e.add('forge:shard/dimshard', 'rftoolsbase:dimensionalshard')
  e.add('forge:essence/inferium', 'mysticalagriculture:inferium_essence')
  e.add('forge:ores/emeraldite', 'byg:emeraldite_ore')
  e.add('forge:gems/ratlantis', 'rats:gem_of_ratlantis')
  e.add('forge:gems/endumium', 'farlanders:endumium_crystal')
  e.add('forge:ores/lapis', 'gildedingot:basalt_lapis')
  e.add('forge:ores/cheese', 'rats:cheese_ore')
  e.add('forge:ores/ratlantean', 'rats:ratlantean_gem_ore')
  e.add('forge:ores/starmetal', 'astralsorcery:starmetal_ore')
  e.add('forge:shard/ender', 'betterendforge:ender_shard')
  e.add('forge:gems/amber', 'betterendforge:raw_amber')
  e.add('forge:anthracite', 'byg:anthracite')
  e.add('forge:lignite', 'byg:lignite')
  e.add('forge:dusts/soulium', 'mysticalagriculture:soulium_dust')
  e.add('forge:pendorite', 'byg:raw_pendorite')
  e.add('forge:emeraldite', 'byg:emeraldite_shards')
  e.add('forge:rats/cheese', 'rats:cheese')

  //DENSE
  e.get('forge:ores/coal').remove('janoeo:dense_coal_ore')
  e.get('forge:ores/copper').remove('janoeo:dense_copper_ore')
  e.get('forge:ores/diamond').remove('janoeo:dense_diamond_ore')
  e.get('forge:ores/emerald').remove('janoeo:dense_emerald_ore')
  e.get('forge:ores/gold').remove('janoeo:dense_gold_ore')
  e.get('forge:ores/iron').remove('janoeo:dense_iron_ore')
  e.get('forge:ores/lapis').remove('janoeo:dense_lapis_ore')
  e.get('forge:ores/redstone').remove('janoeo:dense_redstone_ore')
  e.get('forge:ores/tin').remove('janoeo:dense_tin_ore')
  e.get('forge:ores/quartz').remove('janoeo:dense_quartz_nether_ore')
  e.get('forge:ores/coal').remove('janoeo:dense_coal_nether_ore')
  e.get('forge:ores/diamond').remove('janoeo:dense_diamond_nether_ore')
  e.get('forge:ores/emerald').remove('janoeo:dense_emerald_nether_ore')
  e.get('forge:ores/gold').remove('janoeo:dense_gold_nether_ore')
  e.get('forge:ores/iron').remove('janoeo:dense_iron_nether_ore')
  e.get('forge:ores/lapis').remove('janoeo:dense_lapis_nether_ore')
  e.get('forge:ores/redstone').remove('janoeo:dense_redstone_nether_ore')
  
  e.add('forge:ores/dense/coal','janoeo:dense_coal_ore')
  e.add('forge:ores/dense/copper','janoeo:dense_copper_ore')
  e.add('forge:ores/dense/diamond','janoeo:dense_diamond_ore')
  e.add('forge:ores/dense/emerald','janoeo:dense_emerald_ore')
  e.add('forge:ores/dense/gold','janoeo:dense_gold_ore')
  e.add('forge:ores/dense/iron','janoeo:dense_iron_ore')
  e.add('forge:ores/dense/lapis','janoeo:dense_lapis_ore')
  e.add('forge:ores/dense/redstone','janoeo:dense_redstone_ore')
  e.add('forge:ores/dense/tin','janoeo:dense_tin_ore')
  e.add('forge:ores/dense/quartz','janoeo:dense_quartz_nether_ore')
  e.add('forge:ores/dense/coal','janoeo:dense_coal_nether_ore')
  e.add('forge:ores/dense/diamond','janoeo:dense_diamond_nether_ore')
  e.add('forge:ores/dense/emerald','janoeo:dense_emerald_nether_ore')
  e.add('forge:ores/dense/gold','janoeo:dense_gold_nether_ore')
  e.add('forge:ores/dense/iron','janoeo:dense_iron_nether_ore')
  e.add('forge:ores/dense/lapis','janoeo:dense_lapis_nether_ore')
  e.add('forge:ores/dense/redstone','janoeo:dense_redstone_nether_ore')

  //Disk
  e.get('refinedstorage:parts/items/256k').remove('extrastorage:storagepart_256k')
  e.get('refinedstorage:parts/items/1024k').remove('extrastorage:storagepart_1024k')
  e.get('refinedstorage:parts/items/4096k').remove('extrastorage:storagepart_4096k')
  e.get('refinedstorage:parts/items/16384k').remove('extrastorage:storagepart_16384k')

})

events.listen('block.tags', function (e) {

  //ores
  e.get('forge:ores/copper').remove('mekanism:copper_ore')
  e.get('forge:ores/copper').remove('immersiveengineering:ore_copper')
  e.get('forge:ores/copper').remove('iceandfire:copper_ore')
  e.get('forge:ores/copper').remove('tconstruct:copper_ore')
  e.get('forge:ores/copper').remove('janoeo:copper_ore')
  e.get('forge:ores/copper').remove('create:copper_ore')
  e.get('forge:ores/copper').remove('bluepower:copper_ore')
  e.get('forge:ores/tin').remove('mekanism:tin_ore')
  e.get('forge:ores/tin').remove('janoeo:tin_ore')
  e.get('forge:ores/silver').remove('immersiveengineering:ore_silver')
  e.get('forge:ores/silver').remove('iceandfire:silver_ore')
  e.get('forge:ores/silver').remove('bluepower:silver_ore')
  e.get('forge:ores/silver').remove('janoeo:silver_ore')
  e.get('forge:ores/uranium').remove('mekanism:uranium_ore')
  e.get('forge:ores/uranium').remove('immersiveengineering:ore_uranium')
  e.get('forge:ores/zinc').remove('create:zinc_ore')
  e.get('forge:ores/zinc').remove('bluepower:zinc_ore')
  e.get('forge:ores/lead').remove('mekanism:lead_ore')
  e.get('forge:ores/lead').remove('immersiveengineering:ore_lead')
  e.get('forge:ores/lead').remove('eidolon:lead_ore')
  e.get('forge:ores/lead').remove('janoeo:lead_ore')
  e.get('forge:ores/nickel').remove('immersiveengineering:ore_nickel')
  e.get('forge:ores/aluminum').remove('immersiveengineering:ore_aluminum')
  e.get('forge:ores/osmium').remove('janoeo:osmium_ore')
  e.get('forge:ores/sapphire').remove('janoeo:sapphire_ore')
  e.get('forge:ores/sapphire').remove('janoeo:sapphire_nether_ore')
  e.get('forge:ores/sapphire').remove('thermal:sapphire_ore')
  e.get('forge:ores/ruby').remove('janoeo:ruby_ore')
  e.get('forge:ores/ruby').remove('janoeo:ruby_nether_ore')
  e.get('forge:ores/ruby').remove('thermal:ruby_ore')
  e.get('forge:ores/amethyst').remove('janoeo:amethyst_ore')
  e.get('forge:ores/uranium').remove('bigreactors:yellorite_ore')
  
  e.add('forge:ores/gold', 'byg:brimstone_nether_gold_ore')
  e.add('forge:ores/gold', 'byg:blue_nether_gold_ore')
  
  //Valid Apiary  
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_dark_ethereal')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_dark_ethereal_reverse')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_ethereal')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_ethereal_reverse')
  e.add('resourcefulbees:valid_apiary', 'glassential:glass_ghostly')

})